static const char rcsid[] =
"$Id: glopcvt.c,v 1.5 1995/11/21 05:47:04 schwartz Exp schwartz $";

#include "globin/genie.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

void show_var (int level, varlink *var);
int show_tup (int level, tuplink *tup, char*);
varlink* genie_load_schema (FILE*);
tuplink* genie_load_data (FILE*, varlink*);

void yytrestart (FILE*);
void yytparse (void);
void yysrestart (FILE*);
void yysparse (void);

void maplist (void (*)(FILE*,instance*), FILE*, tuplink*);
FILE* ckopen(char*);

char* argv0;
char dschema[128] = "/depot/globin/data/schemas/schemas";
char ddata[128] =   "/depot/globin/data/tuples/tuples";

extern int verbose;

int main (int argc, char **argv)
{
  char* pdata = (argc > 1) ? argv[1] : ddata;
  char* pschema = (argc > 2) ? argv[2] : dschema;
  FILE* fschema = ckopen(pschema);
  FILE* fdata = ckopen(pdata);
  varlink* schema = genie_load_schema(fschema);
  tuplink* data = genie_load_data(fdata, schema);
 
  argv0 = argv[0];

  if (0) { 
      show_var(0, schema); printf("\n\n"); 
  }
  if (1) { 

/*
      printf("data(list([\n");
      show_tup(1, data, ",%top\n"); 
      printf("])).\n");
Gudjon
*/

      show_tup(1, data, ".%top\n");
      printf(".\n");
  }

  return 0;
}

FILE* ckopen(char* name)
{
  FILE* fp = fopen(name, "r");
  if (!fp) {
    fprintf(stderr, "%s: fopen(%s): %s\n", argv0, name, strerror(errno));
    exit(1);
  } 
  return fp;
}

tuplink* genie_load_data(FILE* file, varlink* schema)
{
  yytrestart (file);
  yytparse ();
  return data->u.t.tuplist;
}

varlink* genie_load_schema(FILE* file)
{
  yysrestart (file);
  yysparse ();
  return schema->varlist;
}

void maplist (void (*fmt)(FILE*,instance*), FILE* out, tuplink* data)
{
  for ( ; data; data = data->next)
    fmt(out, data->values);
}
